package de.jmstest;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;


import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.BytesMessage;
import javax.jms.Message;
import javax.jms.MessageListener;

/**
 * Message-Driven Bean implementation class for: ClientOne
 * 
 */
@MessageDriven(activationConfig = {
		@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = "java:/topic/TOPIC_PERSISTENT"

		),
		@ActivationConfigProperty(propertyName = "clientID", propertyValue = "one"),
		
		@ActivationConfigProperty(propertyName = "maxSession", propertyValue = "100") }, mappedName = "java:/topic/TOPIC_PERSISTENT")
public class ClientOne implements MessageListener {

	
	/**
	 * Default constructor.
	 */
	public ClientOne() {

	}

	/**
	 * @see MessageListener#onMessage(Message)
	 */
	public void onMessage(Message message) {
		try {
			
		if ( message instanceof BytesMessage ) {
			String info  = message.getStringProperty("INFO");
			System.out.println("received:" + info);
		
			BytesMessage bm = (BytesMessage) message;
			
			//CmisStream aus der Message erzeugen
			File outputFile = new File("1_" + bm.getJMSMessageID().substring(bm.getJMSMessageID().indexOf(':') + 1) + ".dat");
			System.out.println("client 1 writing " + outputFile.getAbsolutePath() );
			FileOutputStream fileOutputStream = new FileOutputStream(outputFile);
				BufferedOutputStream bufferedOutput = new BufferedOutputStream(fileOutputStream, 8192);  
				bm.setObjectProperty("JMS_HQ_SaveStream", bufferedOutput);
				
				fileOutputStream.close();
				outputFile.delete();
				
		}
		
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
